/*
 *  Routine for IRQ handling of GF1/InterWave chip
 *  Copyright (c) by Jaroslav Kysela <perex@jcu.cz>
 */

#include "driver.h"
#include "gus.h"

void snd_gus_interrupt( snd_gus_card_t *gus, unsigned char status )
{
#if 0
  if ( status & 0x01 ) {
    STAT_ADD( card -> gf1.interrupt_stat_midi_out );
    card -> gf1.interrupt_handler_midi_out( card );
  }
  if ( status & 0x02 ) {
    STAT_ADD( card -> gf1.interrupt_stat_midi_in );
    card -> gf1.interrupt_handler_midi_in( card );
  }
  if ( status & ( 0x20 | 0x40 ) ) {
    unsigned int i, already, _current_;
    unsigned char voice_status, voice;
    struct GF1_STRU_VOICE_RANGE *range;
          
    already = 0;
    while ( ( ( voice_status = snd_i_read8( card, GF1_GB_VOICES_IRQ ) ) & 0xc0 ) != 0xc0 ) {
      voice = voice_status & 0x1f;
      _current_ = 1 << voice;
      if ( already & _current_ ) continue;	/* multi request */
      already |= _current_;			/* mark request */
      gf1_select_voice( card, voice );
#if 0
      printk( "voice = %i, voice_status = 0x%x, voice_verify = %i\n", voice, voice_status, INB( GUSP( card, GF1PAGE ) ) );
#endif
      i = 0;
      range = card -> gf1.voice_ranges;
      while ( i < GF1_VOICE_RANGES ) {
        if ( voice >= range -> min && voice <= range -> max ) {
          if ( !(voice_status & 0x80) ) {	/* voice position IRQ */
            STAT_ADD( range -> interrupt_stat_wave );
            range -> interrupt_handler_wave( card, voice );
          }
          if ( !(voice_status & 0x40) ) {	/* volume ramp IRQ */
            STAT_ADD( range -> interrupt_stat_volume );
            range -> interrupt_handler_volume( card, voice );
          }
          goto __speedup1;
        }
        i++;
        range++;
      }
      STAT_ADD( card -> gf1.interrupt_stat_voice_lost );
      snd_ctrl_stop( card, GF1_VB_ADDRESS_CONTROL );
      snd_ctrl_stop( card, GF1_VB_VOLUME_CONTROL );
      __speedup1:
    }
  }
  if ( status & 0x04 ) {
    STAT_ADD( card -> gf1.interrupt_stat_timer1 );
    card -> gf1.interrupt_handler_timer1( card );
  }
  if ( status & 0x08 ) {
    STAT_ADD( card -> gf1.interrupt_stat_timer2 );
    card -> gf1.interrupt_handler_timer2( card );
  }
  if ( status & 0x80 ) {
    if ( snd_i_look8( card, GF1_GB_DRAM_DMA_CONTROL ) & 0x40 ) {
      STAT_ADD( card -> gf1.interrupt_stat_dma_write );
      if ( card -> gf1.mode & GF1_MODE_PCM_PLAY )
        card -> gf1.interrupt_handler_pcm_dma_write( card );
       else
        card -> gf1.interrupt_handler_synth_dma_write( card );
    }
    if ( snd_i_look8( card, GF1_GB_REC_DMA_CONTROL ) & 0x40 ) {
      STAT_ADD( card -> gf1.interrupt_stat_dma_read );
      card -> gf1.interrupt_handler_pcm_dma_read( card );
    }
  }
#endif
}
